    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.lang.StringBuffer

    java.lang.Object
       |
       +----java.lang.StringBuffer

public final class StringBuffer
extends Object
implements Serializable

A string buffer implements a mutable sequence of characters.

String buffers are safe for use by multiple threads. The methods are synchronized where necessary so that all the operations on any particular instance behave as if they occur in some serial order.

String buffers are used by the compiler to implement the binary string concatenation operator `+`. For example, the code:

>          x = "a" + 4 + "c"

is compiled to the equivalent of:

>          x = new StringBuffer().append("a").append(4).append("c")
>                                .toString()

The principal operations on a `StringBuffer` are the `append` and `insert` methods, which are overloaded so as to accept data of any type. Each effectively converts a given datum to a string and then appends or inserts the characters of that string to the string buffer. The `append` method always adds these characters at the end of the buffer; the `insert` method adds the characters at a specified point.

For example, if `z` refers to a string buffer object whose current contents are "`start`", then the method call `z.append("le")` would cause the string buffer to contain "`startle`", whereas `z.insert(4, "le")` would alter the string buffer to contain "`starlet`".

Every string buffer has a capacity. As long as the length of the character sequence contained in the string buffer does not exceed the capacity, it is not necessary to allocate a new internal buffer array. If the internal buffer overflows, it is automatically made larger.

See Also:
  ByteArrayOutputStream, String

##

StringBuffer()
  Constructs a string buffer with no characters in it and an initial capacity of 16 characters.
StringBuffer(int)
  Constructs a string buffer with no characters in it and an initial capacity specified by the `length` argument.
StringBuffer(String)
  Constructs a string buffer so that it represents the same sequence of characters as the string argument.

##

append(boolean)
  Appends the string representation of the `boolean` argument to the string buffer.
append(char)
  Appends the string representation of the `char` argument to this string buffer.
append(char[])
  Appends the string representation of the `char` array argument to this string buffer.
append(char[], int, int)
  Appends the string representation of a subarray of the `char` array argument to this string buffer.
append(double)
  Appends the string representation of the `double` argument to this string buffer.
append(float)
  Appends the string representation of the `float` argument to this string buffer.
append(int)
  Appends the string representation of the `int` argument to this string buffer.
append(long)
  Appends the string representation of the `long` argument to this string buffer.
append(Object)
  Appends the string representation of the `Object` argument to this string buffer.
append(String)
  Appends the string to this string buffer.
capacity()
  Returns the current capacity of the String buffer.
charAt(int)
  Returns the character at a specific index in this string buffer.
ensureCapacity(int)
  Ensures that the capacity of the buffer is at least equal to the specified minimum.
getChars(int, int, char[], int)
  Characters are copied from this string buffer into the destination character array `dst`.
insert(int, boolean)
  Inserts the string representation of the `boolean` argument into this string buffer.
insert(int, char)
  Inserts the string representation of the `char` argument into this string buffer.
insert(int, char[])
  Inserts the string representation of the `char` array argument into this string buffer.
insert(int, double)
  Inserts the string representation of the `double` argument into this string buffer.
insert(int, float)
  Inserts the string representation of the `float` argument into this string buffer.
insert(int, int)
  Inserts the string representation of the second `int` argument into this string buffer.
insert(int, long)
  Inserts the string representation of the `long` argument into this string buffer.
insert(int, Object)
  Inserts the string representation of the `Object` argument into this string buffer.
insert(int, String)
  Inserts the string into this string buffer.
length()
  Returns the length (character count) of this string buffer.
reverse()
  The character sequence contained in this string buffer is replaced by the reverse of the sequence.
setCharAt(int, char)
  The character at the specified index of this string buffer is set to `ch`.
setLength(int)
  Sets the length of this String buffer.
toString()
  Converts to a string representing the data in this string buffer.

##

StringBuffer

     public StringBuffer()

  Constructs a string buffer with no characters in it and an initial capacity of 16 characters.

StringBuffer

     public StringBuffer(int length)

  Constructs a string buffer with no characters in it and an initial capacity specified by the `length` argument.

  Parameters:
    length - the initial capacity.
  Throws: NegativeArraySizeException
    if the `length` argument is less than `0`.

StringBuffer

     public StringBuffer(String str)

  Constructs a string buffer so that it represents the same sequence of characters as the string argument. The initial capacity of the string buffer is `16` plus the length of the string argument.

  Parameters:
    str - the initial contents of the buffer.

##

length

     public int length()

  Returns the length (character count) of this string buffer.

  Returns:
    the number of characters in this string buffer.

capacity

     public int capacity()

  Returns the current capacity of the String buffer. The capacity is the amount of storage available for newly inserted characters; beyond which an allocation will occur.

  Returns:
    the current capacity of this string buffer.

ensureCapacity

     public synchronized void ensureCapacity(int minimumCapacity)

  Ensures that the capacity of the buffer is at least equal to the specified minimum. If the current capacity of this string buffer is less than the argument, then a new internal buffer is allocated with greater capacity. The new capacity is the larger of:
  - The `minimumCapacity` argument.
  - Twice the old capacity, plus `2`.
  If the `minimumCapacity` argument is nonpositive, this method takes no action and simply returns.

  Parameters:
    minimumCapacity - the minimum desired capacity.

setLength

     public synchronized void setLength(int newLength)

  Sets the length of this String buffer. If the `newLength` argument is less than the current length of the string buffer, the string buffer is truncated to contain exactly the number of characters given by the `newLength` argument.

  If the `newLength` argument is greater than or equal to the current length, sufficient null characters (`'\u0000'`) are appended to the string buffer so that length becomes the `newLength` argument.

  The `newLength` argument must be greater than or equal to `0`.

  Parameters:
    newLength - the new length of the buffer.
  Throws: StringIndexOutOfBoundsException
    if the `newLength` argument is invalid.
  See Also:
    length

charAt

     public synchronized char charAt(int index)

  Returns the character at a specific index in this string buffer.

  The first character of a string buffer is at index `0`, the next at index `1`, and so on, for array indexing.

  The index argument must be greater than or equal to `0`, and less than the length of this string buffer.

  Parameters:
    index - the index of the desired character.
  Returns:
    the character at the specified index of this string buffer.
  Throws: StringIndexOutOfBoundsException
    if the index is invalid.
  See Also:
    length

getChars

     public synchronized void getChars(int srcBegin,
                                       int srcEnd,
                                       char dst[],
                                       int dstBegin)

  Characters are copied from this string buffer into the destination character array `dst`. The first character to be copied is at index `srcBegin`; the last character to be copied is at index `srcEnd-1.` The total number of characters to be copied is `srcEnd-srcBegin`. The characters are copied into the subarray of `dst` starting at index `dstBegin` and ending at index:

  >          dstbegin + (srcEnd-srcBegin) - 1

  Parameters:
    srcBegin - start copying at this offset in the string buffer.
    srcEnd - stop copying at this offset in the string buffer.
    dst - the array to copy the data into.
    dstBegin - offset into `dst`.
  Throws: StringIndexOutOfBoundsException
    if there is an invalid index into the buffer.

setCharAt

     public synchronized void setCharAt(int index,
                                        char ch)

  The character at the specified index of this string buffer is set to `ch`.

  The offset argument must be greater than or equal to `0`, and less than the length of this string buffer.

  Parameters:
    index - the index of the character to modify.
    ch - the new character.
  Throws: StringIndexOutOfBoundsException
    if the index is invalid.
  See Also:
    length

append

     public synchronized StringBuffer append(Object obj)

  Appends the string representation of the `Object` argument to this string buffer.

  The argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then appended to this string buffer.

  Parameters:
    obj - an `Object`.
  Returns:
    this string buffer.
  See Also:
    valueOf, append

append

     public synchronized StringBuffer append(String str)

  Appends the string to this string buffer.

  The characters of the `String` argument are appended, in order, to the contents of this string buffer, increasing the length of this string buffer by the length of the argument.

  Parameters:
    str - a string.
  Returns:
    this string buffer.

append

     public synchronized StringBuffer append(char str[])

  Appends the string representation of the `char` array argument to this string buffer.

  The characters of the array argument are appended, in order, to the contents of this string buffer. The length of this string buffer increases by the length of the argument.

  Parameters:
    str - the characters to be appended.
  Returns:
    this string buffer.

append

     public synchronized StringBuffer append(char str[],
                                             int offset,
                                             int len)

  Appends the string representation of a subarray of the `char` array argument to this string buffer.

  Characters of the character array `str`, starting at index `offset`, are appended, in order, to the contents of this string buffer. The length of this string buffer increases by the value of `len`.

  Parameters:
    str - the characters to be appended.
    offset - the index of the first character to append.
    len - the number of characters to append.
  Returns:
    this string buffer.

append

     public StringBuffer append(boolean b)

  Appends the string representation of the `boolean` argument to the string buffer.

  The argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then appended to this string buffer.

  Parameters:
    b - a `boolean`.
  Returns:
    this string buffer.
  See Also:
    valueOf, append

append

     public synchronized StringBuffer append(char c)

  Appends the string representation of the `char` argument to this string buffer.

  The argument is appended to the contents of this string buffer. The length of this string buffer increases by `1`.

  Parameters:
    ch - a `char`.
  Returns:
    this string buffer.

append

     public StringBuffer append(int i)

  Appends the string representation of the `int` argument to this string buffer.

  The argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then appended to this string buffer.

  Parameters:
    i - an `int`.
  Returns:
    this string buffer.
  See Also:
    valueOf, append

append

     public StringBuffer append(long l)

  Appends the string representation of the `long` argument to this string buffer.

  The argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then appended to this string buffer.

  Parameters:
    l - a `long`.
  Returns:
    this string buffer.
  See Also:
    valueOf, append

append

     public StringBuffer append(float f)

  Appends the string representation of the `float` argument to this string buffer.

  The argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then appended to this string buffer.

  Parameters:
    f - a `float`.
  Returns:
    this string buffer.
  See Also:
    valueOf, append

append

     public StringBuffer append(double d)

  Appends the string representation of the `double` argument to this string buffer.

  The argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then appended to this string buffer.

  Parameters:
    d - a `double`.
  Returns:
    this string buffer.
  See Also:
    valueOf, append

insert

     public synchronized StringBuffer insert(int offset,
                                             Object obj)

  Inserts the string representation of the `Object` argument into this string buffer.

  The second argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then inserted into this string buffer at the indicated offset.

  The offset argument must be greater than or equal to `0`, and less than or equal to the length of this string buffer.

  Parameters:
    offset - the offset.
    b - an `Object`.
  Returns:
    this string buffer.
  Throws: StringIndexOutOfBoundsException
    if the offset is invalid.
  See Also:
    valueOf, insert, length

insert

     public synchronized StringBuffer insert(int offset,
                                             String str)

  Inserts the string into this string buffer.

  The characters of the `String` argument are inserted, in order, into this string buffer at the indicated offset. The length of this string buffer is increased by the length of the argument.

  The offset argument must be greater than or equal to `0`, and less than or equal to the length of this string buffer.

  Parameters:
    offset - the offset.
    str - a string.
  Returns:
    this string buffer.
  Throws: StringIndexOutOfBoundsException
    if the offset is invalid.
  See Also:
    length

insert

     public synchronized StringBuffer insert(int offset,
                                             char str[])

  Inserts the string representation of the `char` array argument into this string buffer.

  The characters of the array argument are inserted into the contents of this string buffer at the position indicated by `offset`. The length of this string buffer increases by the length of the argument.

  Parameters:
    offset - the offset.
    ch - a character array.
  Returns:
    this string buffer.
  Throws: StringIndexOutOfBoundsException
    if the offset is invalid.

insert

     public StringBuffer insert(int offset,
                                boolean b)

  Inserts the string representation of the `boolean` argument into this string buffer.

  The second argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then inserted into this string buffer at the indicated offset.

  The offset argument must be greater than or equal to `0`, and less than or equal to the length of this string buffer.

  Parameters:
    offset - the offset.
    b - a `boolean`.
  Returns:
    this string buffer.
  Throws: StringIndexOutOfBoundsException
    if the offset is invalid.
  See Also:
    valueOf, insert, length

insert

     public synchronized StringBuffer insert(int offset,
                                             char c)

  Inserts the string representation of the `char` argument into this string buffer.

  The second argument is inserted into the contents of this string buffer at the position indicated by `offset`. The length of this string buffer increases by one.

  The offset argument must be greater than or equal to `0`, and less than or equal to the length of this string buffer.

  Parameters:
    offset - the offset.
    ch - a `char`.
  Returns:
    this string buffer.
  Throws: StringIndexOutOfBoundsException
    if the offset is invalid.
  See Also:
    length

insert

     public StringBuffer insert(int offset,
                                int i)

  Inserts the string representation of the second `int` argument into this string buffer.

  The second argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then inserted into this string buffer at the indicated offset.

  The offset argument must be greater than or equal to `0`, and less than or equal to the length of this string buffer.

  Parameters:
    offset - the offset.
    b - an `int`.
  Returns:
    this string buffer.
  Throws: StringIndexOutOfBoundsException
    if the offset is invalid.
  See Also:
    valueOf, insert, length

insert

     public StringBuffer insert(int offset,
                                long l)

  Inserts the string representation of the `long` argument into this string buffer.

  The second argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then inserted into this string buffer at the indicated offset.

  The offset argument must be greater than or equal to `0`, and less than or equal to the length of this string buffer.

  Parameters:
    offset - the offset.
    b - a `long`.
  Returns:
    this string buffer.
  Throws: StringIndexOutOfBoundsException
    if the offset is invalid.
  See Also:
    valueOf, insert, length

insert

     public StringBuffer insert(int offset,
                                float f)

  Inserts the string representation of the `float` argument into this string buffer.

  The second argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then inserted into this string buffer at the indicated offset.

  The offset argument must be greater than or equal to `0`, and less than or equal to the length of this string buffer.

  Parameters:
    offset - the offset.
    b - a `float`.
  Returns:
    this string buffer.
  Throws: StringIndexOutOfBoundsException
    if the offset is invalid.
  See Also:
    valueOf, insert, length

insert

     public StringBuffer insert(int offset,
                                double d)

  Inserts the string representation of the `double` argument into this string buffer.

  The second argument is converted to a string as if by the method `String.valueOf`, and the characters of that string are then inserted into this string buffer at the indicated offset.

  The offset argument must be greater than or equal to `0`, and less than or equal to the length of this string buffer.

  Parameters:
    offset - the offset.
    b - a `double`.
  Returns:
    this string buffer.
  Throws: StringIndexOutOfBoundsException
    if the offset is invalid.
  See Also:
    valueOf, insert, length

reverse

     public synchronized StringBuffer reverse()

  The character sequence contained in this string buffer is replaced by the reverse of the sequence.

  Returns:
    this string buffer.

toString

     public String toString()

  Converts to a string representing the data in this string buffer. A new `String` object is allocated and initialized to contain the character sequence currently represented by this string buffer. This `String` is then returned. Subsequent changes to the string buffer do not affect the contents of the `String`.

  Returns:
    a string representation of the string buffer.
  Overrides:
    toString in class Object

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.